@echo off

echo Note:  Some parts of gufbuild take an extremely long time
echo        to compile.  Please be patient.

mkdir build
mkdir include
mkdir include\gufbuild
echo Compiling Platform...
copy src\gufbuild\Platform.h.win32 src\gufbuild\Platform.h
copy src\gufbuild\Platform.h include\gufbuild
echo Compiling Filesystem...
c++ -O2 -Wall -c src/gufbuild/Filesystem.cpp   -o build/gufbuild_Filesystem.o   || goto ERROR
echo Compiling Process...
c++ -O2 -Wall -c src/gufbuild/Process.cpp      -o build/gufbuild_Process.o      || goto ERROR
echo Compiling Preprocessor...
c++ -O2 -Wall -c src/gufbuild/Preprocessor.cpp -o build/gufbuild_Preprocessor.o || goto ERROR
echo Compiling Compiler...
c++ -O2 -Wall -c src/gufbuild/Compiler.cpp     -o build/gufbuild_Compiler.o     || goto ERROR
echo Compiling Buildable...
c++ -O2 -Wall -c src/gufbuild/Buildable.cpp    -o build/gufbuild_Buildable.o    || goto ERROR
echo Compiling Module...
c++ -O2 -Wall -c src/gufbuild/Module.cpp       -o build/gufbuild_Module.o       || goto ERROR
echo Compiling Package...
c++ -O2 -Wall -c src/gufbuild/Package.cpp      -o build/gufbuild_Package.o      || goto ERROR
echo Compiling Binary...
c++ -O2 -Wall -c src/gufbuild/Binary.cpp       -o build/gufbuild_Binary.o       || goto ERROR
echo Compiling ParseElement...
c++ -O2 -Wall -c src/gufbuild/ParseElement.cpp -o build/gufbuild_ParseElement.o || goto ERROR
echo Compiling Parser...
c++ -O2 -Wall -c src/gufbuild/Parser.cpp       -o build/gufbuild_Parser.o       || goto ERROR
echo Compiling BuildfileElement...
c++ -O2 -Wall -c src/gufbuild/BuildfileElement.cpp -o build/gufbuild_BuildfileElement.o || goto ERROR
echo Compiling GufBuild...
c++ -O2 -Wall -c src/gufbuild/GufBuild.cpp     -o build/gufbuild_GufBuild.o     || goto ERROR

mkdir bin
echo Linking gufbuild...
c++ -O2 -o bin/gufbuild build/gufbuild_*.o || goto ERROR

echo Build Succeeded...
goto END

:ERROR
echo Build Failed...

:END
pause
